# This file was generated by liblab | https://liblab.com/

from .utils.validator import Validator
from .utils.base_service import BaseService
from ..net.transport.serializer import Serializer
from ..models.utils.cast_models import cast_models
from ..models import Project


class ProjectService(BaseService):

    @cast_models
    def info(self) -> Project:
        """Obtain project information

        ...
        :raises RequestError: Raised when a request fails, with optional HTTP status code and details.
        ...
        :return: Successful Response
        :rtype: Project
        """

        serialized_request = (
            Serializer(f"{self.base_url}/project/info", self.get_default_headers())
            .serialize()
            .set_method("GET")
        )

        response = self.send_request(serialized_request)
        return Project._unmap(response)

    @cast_models
    def collect(self) -> any:
        """collect

        ...
        :raises RequestError: Raised when a request fails, with optional HTTP status code and details.
        ...
        :return: Successful Response
        :rtype: any
        """

        serialized_request = (
            Serializer(f"{self.base_url}/project/collect", self.get_default_headers())
            .serialize()
            .set_method("POST")
        )

        response = self.send_request(serialized_request)
        return response

    @cast_models
    def generate(self) -> any:
        """generate

        ...
        :raises RequestError: Raised when a request fails, with optional HTTP status code and details.
        ...
        :return: Successful Response
        :rtype: any
        """

        serialized_request = (
            Serializer(f"{self.base_url}/project/generate", self.get_default_headers())
            .serialize()
            .set_method("POST")
        )

        response = self.send_request(serialized_request)
        return response

    @cast_models
    def build(self) -> any:
        """build

        ...
        :raises RequestError: Raised when a request fails, with optional HTTP status code and details.
        ...
        :return: Successful Response
        :rtype: any
        """

        serialized_request = (
            Serializer(f"{self.base_url}/project/build", self.get_default_headers())
            .serialize()
            .set_method("POST")
        )

        response = self.send_request(serialized_request)
        return response

    @cast_models
    def view(self) -> any:
        """view

        ...
        :raises RequestError: Raised when a request fails, with optional HTTP status code and details.
        ...
        :return: Successful Response
        :rtype: any
        """

        serialized_request = (
            Serializer(f"{self.base_url}/project/view", self.get_default_headers())
            .serialize()
            .set_method("POST")
        )

        response = self.send_request(serialized_request)
        return response

    @cast_models
    def imagine(self, target: str = None) -> any:
        """imagine

        :param target: target, defaults to None
        :type target: str, optional
        ...
        :raises RequestError: Raised when a request fails, with optional HTTP status code and details.
        ...
        :return: Successful Response
        :rtype: any
        """

        Validator(str).is_optional().validate(target)

        serialized_request = (
            Serializer(f"{self.base_url}/project/imagine", self.get_default_headers())
            .add_query("target", target, nullable=True)
            .serialize()
            .set_method("POST")
        )

        response = self.send_request(serialized_request)
        return response
